# Ch4 Programming Practice
import numpy as np
import matplotlib.pyplot as plt

# Dpf, D0f, Dmf, f
def Dpf(F,a,h):
    return (F(a+h)-F(a))/h
    
def D0f(F,a,h):
    return (F(a+h)-F(a-h))/(2*h)
    
def Dmf(F,a,h):
    return (F(a)-F(a-h))/h
    
def f(x):
    return np.exp(x)
    
def df(x):
    return 2*x*np.exp(x)
    
# Main function
a = 2

h_list = []
fmDpf_list = []
fmD0f_list = []
fmDmf_list = []

for i in range(11):
    h = (1.0/2.0)**i
    h_list.append(h)
    
    fmDpf = np.abs(f(a)-Dpf(f,a,h))
    fmD0f = np.abs(f(a)-D0f(f,a,h))
    fmDmf = np.abs(f(a)-Dmf(f,a,h))
    
    fmDpf_list.append(fmDpf)
    fmD0f_list.append(fmD0f)
    fmDmf_list.append(fmDmf)
    
# Visualization
graph1, = plt.loglog(h_list,fmDpf_list,'o-')
graph2, = plt.loglog(h_list,fmD0f_list,'o-')
graph3, = plt.loglog(h_list,fmDmf_list,'o-')

plt.legend(handles=(graph1,graph2,graph3),
            labels=(r'$|D_+f(a)-f(a)|$',r'$|D_0f(a)-f(a)|$',r'$|D_-f(a)-f(a)|$'),
            loc='lower right')
            
plt.show()